# coding: latin-1
"""
 Beispiel: Autorennen,  Variante 2
 Diese Variante benutzt die "Ereignis-Anwendung".
 Dieses mal wird die Klasse als Spezialisierung der Klasse Sprite erstellt.


 Definition einer Klasse Auto unter Benutzung der neuen Klasse Sprite.
 Ableitung zweier Instanzen.
 Nutzung einer Schleife mit Tastaturabfrage zur Steuerung der Autos
"""

from sum import *
from ereignisanwendung import *

# Definition eines Autos
class Auto(Sprite):
  def __init__(self,bildschirm):
    self.laden("auto.bmp",bildschirm)
    self.bewegeBis(100,100)
   
  def gibFrei(self):
    pass

  def bewegeUm(self,laenge):
    self.bewegeBis(self.hPosition()+laenge,self.vPosition())
  
  def istAngekommen(self):
    return self.hPosition()>400
    
class RennenAnwendung(EreignisAnwendung):
  def start(self):
    self.auto1=Auto(self.bildschirm)
    self.auto1.bewegeBis(100,100)
    self.auto2=Auto(self.bildschirm)
    self.auto2.bewegeBis(100,200)
    self.sieger=0
    
  def bearbeiteTaste(self,zeichen):
    if zeichen=="y":
      self.auto1.bewegeUm(4) 
    if zeichen=="-":
      self.auto2.bewegeUm(4)
    
    if self.auto1.istAngekommen():
      self.stift.schreibe("Auto1 ist Sieger!")
      self.sieger=1
      self.Beenden()
  
    if self.auto2.istAngekommen():
      self.stift.schreibe("Auto2 ist Sieger!")
      self.sieger=2
      self.Beenden()


# Erzeuge Bildschirm und Maus
anw=RennenAnwendung()
anw.start()
anw.fuehreAus()
anw.gibFrei()
