# coding: latin-1
"""
 Beispiel: Fernlenk-Auto
"""

from sum import *
from math import *
      
class Auto(Sprite):
    """
     Auto realisiert ein steuerbares Fahrzeug.
     Eso erbt alle Methoden von Sprite
    """

    def drehelinks(self):
      "Drehe das Auto nach links."
      self.dreheBis(self.winkel - 30)

    def dreherechts(self):
      "Drehe das Auto nach rechts."
      self.dreheBis(self.winkel + 30)
   
    def fahre(self,tempo):
      "Fahre vorwrts."
      # Eine schlaue Formel zur Berechnung der neuen Position
      xneu=self.hPosition()+tempo*cos(self.winkel*pi/180)
      yneu=self.vPosition()-tempo*sin(self.winkel*pi/180)
      if xneu<0: xneu=0
      if yneu<0: yneu=0
      self.bewegeBis(xneu,yneu)

def main():
    # Erzeuge die ntigen Objekte
    win=Bildschirm("background.gif")
    auto = Auto("auto.bmp",win) 
    auto.setpos( (320,200) )
    
    tast=Tastatur(win)
    maus=Maus(win)
    stift=Stift(win)
    
    tempo=2
    
    # Ein wenig schreiben...
    stift.bewegeBis(20,20)
    stift.runter()
    stift.schreibe("Q=Ende, Y/X=Links-Rechts")

    # Die Steuerungsschleife
    while 1:
    
      if tast.wurdeGedrueckt():
        c=tast.zeichen()
        if c=="x": auto.drehelinks()
        if c=="y": auto.dreherechts()
        if c=="q": break
          
      auto.fahre(1)

    maus.gibFrei()
    stift.gibFrei()
    win.gibFrei()


# call the "main" function if running this script
if __name__ == '__main__': main()
