# coding: latin-1
"""
 Beispiel: Turtle-Grafik mit Visualisierung durch ein nettes Schildkrten-Sprites
"""

from sum import *
from math import *
      
class Turtle(Sprite):
    "Turtle erbt alle Methoden von Sprite"

    def drehe(self,drehwinkel):
      "Drehe die turtle um winkel nach rechts."
      self.dreheBis(self.winkel + drehwinkel)
      
    def gehevor(self,schritte):
      "Gehe schritte (Pixel) vor."
      xneu=self.hPosition()+schritte*cos(self.winkel*pi/180)
      yneu=self.vPosition()-schritte*sin(self.winkel*pi/180)
      self.bewegeBis(xneu,yneu)

def main():
    # Erzeuge die ntigen Objekte
    win=Bildschirm("background.gif")
    turtle = Turtle("turtle.bmp",win) 
    turtle.setpos( (320,200) )
    tast=Tastatur(win)
    maus=Maus(win)
    stift=Stift(win)
    
    # Ein wenig schreiben...
    stift.bewegeBis(turtle.pos[0],turtle.pos[1])
    stift.runter()
    stift.schreibe("Tastendruck zum Beenden.")

    # und die Schildkrte eine Figur zeichnen lassen
    for i in range(1,100):
      turtle.gehevor(150)
      turtle.drehe(170)
      stift.bewegeBis(turtle.pos[0],turtle.pos[1])

    # Eine Schildkrten-Steuerung per Maus
    while not tast.wurdeGedrueckt():
      turtle.gehevor(2)
      stift.bewegeBis(turtle.pos[0],turtle.pos[1])
      if maus.istGedrueckt ():
        turtle.drehe(5)
    
    # Freigeben
    maus.gibFrei()
    stift.gibFrei()
    win.gibFrei()


# call the "main" function if running this script
if __name__ == '__main__': main()
