# coding: latin-1
"""
 Beispiel: Definition einer Klasse Ball
 Nutzung von Radiermodus und Zeichenmodus zur Animation
 Verwaltung interner Zustnde ber Attribute
"""

from sum import *

# Definition eines Balls
class Muehle:
  def __init__(self):
    # Attribute der Muehle
    self.hPosition=100
    self.vPosition=100
    self.winkel=0
  
  def gibFrei(self):
    # Freigeben macht nichts
    pass
    
  def zeichneHaus(self):
    # Ein Haus an der aktuellen x/y-Position zeichnen
    stift.hoch()
    stift.bewegeBis(self.hPosition,self.vPosition)
    stift.runter()
    stift.bewegeBis(self.hPosition+50,self.vPosition+100)
    stift.bewegeBis(self.hPosition-50,self.vPosition+100)
    stift.bewegeBis(self.hPosition,self.vPosition)

  def zeichneFluegel(self):
    # Zeichne 4 Flgel der Winmhle....
    stift.hoch()
    stift.bewegeBis(self.hPosition,self.vPosition)
    stift.runter()

    # Stuft auf den richtigen Winkel setzen...
    stift.dreheBis(self.winkel)
   
    # 4 Flgel Zeichnen,
    for i in range(4):
      stift.bewegeUm(50)
      stift.dreheUm(180)
      stift.bewegeUm(50)
      # Nach jedem Flgel den Stift 90 Grad drehen
      stift.dreheUm(90)

  def bewegeFluegel(self):
    # mich selbst "wegradieren"
    stift.radiere()
    self.zeichneFluegel()   
    self.winkel=self.winkel+2
    if self.winkel>359:
       self.winkel=self.winkel-360 
    # mich zeichnen
    stift.normal()
    self.zeichneFluegel()
    self.zeichneHaus()

# Erzeuge Bildschirm und Stift
bildschirm=Bildschirm()
stift=Buntstift(bildschirm)
maus=Maus(bildschirm)
tastatur=Tastatur(bildschirm)

# Erzeuge ein Objekt "Muehle"
muehle=Muehle()
muehle.zeichneHaus()

# Bewegen bis Mausklick
while 1: #not maus.doppelKlick():
  muehle.bewegeFluegel()
     
# Und Ende.
muehle.gibFrei()
tastatur.gibFrei()
maus.gibFrei()
stift.gibFrei()
bildschirm.gibFrei()
