# coding: latin-1
"""
 Beispiel: Definition einer Klasse Mhle
 NEU: Die Mhle hat einen eigenen Stift.
"""

from sum import *

# Definition eines Balls
class Muehle:
  def __init__(self):
    # Attribute der Muehle
    self.hPosition=100
    self.vPosition=100
    self.winkel=0
    self.stift=Buntstift(bildschirm)
 
  def gibFrei(self):
    # Stift Freigeben.
    self.stift.gibFrei()
    
  def zeichneHaus(self):
    # Ein Haus an der aktuellen x/y-Position zeichnen
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition,self.vPosition)
    self.stift.runter()
    self.stift.bewegeBis(self.hPosition+50,self.vPosition+100)
    self.stift.bewegeBis(self.hPosition-50,self.vPosition+100)
    self.stift.bewegeBis(self.hPosition,self.vPosition)

  def zeichneFluegel(self):
    # Zeichne 4 Flgel der Winmhle....
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition,self.vPosition)
    self.stift.runter()

    # Stuft auf den richtigen Winkel setzen...
    self.stift.dreheBis(self.winkel)
   
    # 4 Flgel Zeichnen,
    for i in range(4):
      self.stift.bewegeUm(50)
      self.stift.dreheUm(180)
      self.stift.bewegeUm(50)
      # Nach jedem Flgel den Stift 90 Grad drehen
      self.stift.dreheUm(90)

  def bewegeFluegel(self):
    # mich selbst "wegradieren"
    self.stift.radiere()
    self.zeichneFluegel()   
    self.winkel=self.winkel+2
    if self.winkel>359:
       self.winkel=self.winkel-360 
    # mich zeichnen
    self.stift.normal()
    self.zeichneFluegel()
    self.zeichneHaus()

# Erzeuge Bildschirm und Stift
bildschirm=Bildschirm()
maus=Maus(bildschirm)
tastatur=Tastatur(bildschirm)

# Erzeuge ein Objekt "Muehle"
muehle=Muehle()
muehle.zeichneHaus()

# Bewegen bis Mausklick
while not maus.doppelKlick():
  muehle.bewegeFluegel()
     
# Und Ende.
muehle.gibFrei()
tastatur.gibFrei()
maus.gibFrei()
bildschirm.gibFrei()
