# coding: latin-1
"""
 Beispiel: Definition einer Klasse Waggon,
 daraus werden spezialisierte Klassen Gueterwagen und Personenwagen abgeleitet.
"""

from sum import *

# Definition eines allgemeinen Waggons
class Waggon:
  def __init__(self):
    self.hPosition=100
    self.vPosition=100
    self.stift=Stift(bildschirm)
  
  def bewegeBis(self,xneu,yneu):
    self.hPosition=xneu
    self.vPosition=yneu
  
  def gibFrei(self):
    self.stift.gibFrei()

  def bewegeUm(self,laenge):
    # mich selbst "wegradieren"
    self.stift.radiere()
    self.zeichne()
    # mich bewegen
    self.hPosition=self.hPosition+laenge   
    # mich zeichnen
    self.stift.normal()
    self.zeichne()
  
  def koppelan(self,vorgaenger):
    self.hPosition = vorgaenger.hPosition - 30
  
  def zeichne(self):
    # Einen Waggon an der aktuellen x/y-Position zeichnen
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition,self.vPosition)
    self.stift.runter()
    self.stift.zeichneRechteck(28,10)
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition+5,self.vPosition+10)
    self.stift.runter()
    self.stift.zeichneKreis(3)
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition+20,self.vPosition+10)
    self.stift.runter()
    self.stift.zeichneKreis(3)
    self.stift.bewegeBis(self.hPosition+28,self.vPosition+5)
    self.stift.zeichneRechteck(2,2)

class Gueterwagen(Waggon):
  def zeichne(self):
    # Einen Waggon an der aktuellen x/y-Position zeichnen
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition,self.vPosition+5)
    self.stift.runter()
    self.stift.zeichneRechteck(28,5)
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition+5,self.vPosition+10)
    self.stift.runter()
    self.stift.zeichneKreis(3)
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition+20,self.vPosition+10)
    self.stift.runter()
    self.stift.zeichneKreis(3)
    self.stift.bewegeBis(self.hPosition+28,self.vPosition+5)
    self.stift.zeichneRechteck(2,2)

class Personenwagen(Waggon):
  def zeichne(self):
    # Einen Waggon an der aktuellen x/y-Position zeichnen
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition,self.vPosition)
    self.stift.runter()
    self.stift.zeichneRechteck(28,10)
    for i in range(4):
      self.stift.hoch()
      self.stift.bewegeBis(self.hPosition+2+i*6,self.vPosition+2)
      self.stift.runter()
      self.stift.zeichneRechteck(4,4)
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition+5,self.vPosition+10)
    self.stift.runter()
    self.stift.zeichneKreis(3)
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition+20,self.vPosition+10)
    self.stift.runter()
    self.stift.zeichneKreis(3)
    self.stift.bewegeBis(self.hPosition+28,self.vPosition+5)
    self.stift.zeichneRechteck(2,2)

class Lok(Waggon):
  def zeichne(self):
    # Einen Waggon an der aktuellen x/y-Position zeichnen
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition+8,self.vPosition+4)
    self.stift.runter()
    self.stift.zeichneRechteck(20,6)

    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition,self.vPosition)
    self.stift.runter()
    self.stift.zeichneRechteck(8,10)
    self.stift.zeichneRechteck(8,2)


    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition+5,self.vPosition+10)
    self.stift.runter()
    self.stift.zeichneKreis(3)
    self.stift.hoch()
    self.stift.bewegeBis(self.hPosition+20,self.vPosition+10)
    self.stift.runter()
    self.stift.zeichneKreis(3)
    self.stift.bewegeBis(self.hPosition+28,self.vPosition+5)
    self.stift.zeichneRechteck(2,2)

    
# Erzeuge Bildschirm und Maus
bildschirm=Bildschirm()
maus=Maus(bildschirm)
tastatur=Tastatur(bildschirm)

# Erzeuge einige Waggons.
lok=Lok()
lok.bewegeBis(100,100)

w1=Personenwagen()
w1.koppelan(lok)

w2=Gueterwagen()
w2.koppelan(w1)

# Ball bewegen bis Mausklick
while not maus.doppelKlick():
  lok.bewegeUm(1)
  w1.bewegeUm(1)
  w2.bewegeUm(1)
     
# Und Ende.
tastatur.gibFrei()
maus.gibFrei()
bildschirm.gibFrei()
